/* CS5 - Channel Services src/parse_srvmsg.c
 * Copyright (c) 1998 Chris Birch <cs5@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> CS4.0
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include <bot.h>

void parse_server_msg(fd_set *read_fds)
{
	int i;
   char *botnum;

   if(FD_ISSET(socketfd, read_fds))
   {
      if(readln() > 0) 
      {
         parse(line);
      }
      else 
      {
         if(trk_servers >= no_servers) trk_servers = 0;
         strcpy(bot.server, servers[trk_servers].name);
         bot.port = servers[trk_servers].port;
         trk_servers++;
         botnum=nick2num(bot.nick);
         delete_node(botnum);
		 free_regslist();
         free_hublist();
         free_nicklist();
         if((i = get_connection(bot.server, bot.port)) != -1)
         {
            log(LOG_FILE, "[%s] Reconnecting to %s\n", date(), bot.server);
            socketfd = i;
            init_bot();
         }
      }
   }
}
void parse_ping(char *who, char *rest)
{
   send_to_server("PONG %s\n", who);
   bot.server_active = TRUE;
}


void parse_pong(char *who, char *rest)
{
   char *ptr = NULL;
   if(ptr = strchr(rest, ' ')) *ptr = '\0';
   if(!strcasecmp(who, rest)) bot.server_active = TRUE;
}

void parse_squit(char *who, char *rest)
{
   char *server = NULL;
   server = who;
   if(!strcasecmp(server, uworldhost)) return;
   remove_hub(server,NULL);
}

void parse_pass(char *who, char *rest)
{
	  char *usernum;
	  if(strcmp(netpass, who)) {
      printf(" **********************************************\n");
      printf(" Password returned from server is not correct! \n");
      printf(" **********************************************\n");
	  log(ERRLOG_FILE, "[%s] Password returned from server is not correct! (server pass [%s] -> my pass [%s]).\n", date(), who, netpass);
	  exit(0);
	  }

	  usernum = makenum(bot.nick);
      send_to_server("NICK %s 1 %ld %s %s %s %s 0 :%s\n", bot.nick, time(NULL), mymodes, ircuser, myhost, myserver, ircname);
      add_nickinfo(bot.nick, ircuser, myhost, usernum, myserver, reason);
      bot.server_active = TRUE;  
      alarm(ALARMINTERVAL);

}

void parse_svinfo()
{
	if(joined == FALSE) {
       join_msgchan();
       join_channels();
       joined = TRUE;
    }
return;
}

void parse_erreur()
{     
	char *botnum;
	int i;
	  botnum=nick2num(bot.nick);
      delete_node(botnum);
      if((i = get_connection(bot.server, bot.port)) != -1)
       {
            log(LOG_FILE, "[%s] Reconnecting to %s\n", date(), bot.server);
            socketfd = i;
            init_bot();
     }
}
